## redis 7.2.5

=== debian/changelog ===
redis (5:7.2.5-2) experimental; urgency=high

  * Fix three new security vulnerabilities:

    - CVE-2024-31227: An authenticated with sufficient privileges could have
      created a malformed ACL selector which, when accessed, triggered a server
      panic and subsequent denial of service.

    - CVE-2024-31228: Authenticated users could have triggered a
      denial-of-service by using specially crafted, long string match patterns
      on supported commands such as `KEYS`, `SCAN`, `PSUBSCRIBE`, `FUNCTION
      LIST`, `COMMAND | LIST` and ACL definitions. Matching of extremely long
      patterns may have resulted in unbounded recursion, leading to stack overflow
      and process crash.

    - CVE-2024-31449: An authenticated user may have used a specially crafted
      Lua script to trigger a stack buffer overflow in the bit library, which
      may have potentially led to remote code execution.

    (Closes: #1084805)

 -- Chris Lamb <lamby@debian.org>  Wed, 09 Oct 2024 13:51:24 -0700

redis (5:7.2.5-1) experimental; urgency=medium

  * New upstream [BSD-licensed] release.

 -- Chris Lamb <lamby@debian.org>  Tue, 04 Jun 2024 08:35:47 +0100

redis (5:7.2.4-1) experimental; urgency=medium

  * New upstream security release:

    - CVE-2023-41056: In some cases, Redis may incorrectly handle resizing of
      memory buffers which can result in incorrect accounting of buffer sizes
      and lead to heap overflow and potential remote code execution.  (Closes:
      #1060316)

    - For more information, please see:
      <https://raw.githubusercontent.com/redis/redis/7.2/00-RELEASENOTES>

  * Refresh patches.

 -- Chris Lamb <lamby@debian.org>  Tue, 09 Jan 2024 14:29:59 +0000

redis (5:7.2.3-1) experimental; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 04 Nov 2023 10:20:29 +0100

redis (5:7.2.2-2) experimental; urgency=medium

  * Drop ProcSubset=pid hardening flag from the systemd unit files it appears
    to cause crashes with memory allocation errors. A huge thanks to Arnaud
    Rebillout <arnaudr@kali.org> for the extensive investigation.
    (Closes: #1055039)

 -- Chris Lamb <lamby@debian.org>  Tue, 31 Oct 2023 16:44:01 +0100

redis (5:7.2.2-1) experimental; urgency=high

  * New upstream security release:

    - CVE-2023-45145: On startup, Redis began listening on a Unix socket before
      adjusting its permissions to the user-provided configuration. If a
      permissive umask(2) was used, this created a race condition that enabled,
      during a short period of time, another process to establish an otherwise
      unauthorized connection. (Closes: #1054225)

  * Refresh patches.

 -- Chris Lamb <lamby@debian.org>  Thu, 19 Oct 2023 15:59:56 +0100

redis (5:7.2.1-2) experimental; urgency=medium

  * Only install systemd units once. Thanks, Helmut! (Closes: #1054091)

 -- Chris Lamb <lamby@debian.org>  Tue, 17 Oct 2023 11:21:34 +0100

redis (5:7.2.1-1) experimental; urgency=medium

  * New upstream security release:

    - CVE-2023-41053: Redis did not correctly identify keys accessed by
      `SORT_RO`, and as a result Redis may grant users executing this command
      access to keys that are not explicitly authorized by the ACL
      configuration. (Closes: #1051512)

    <https://raw.githubusercontent.com/redis/redis/7.2/00-RELEASENOTES>

 -- Chris Lamb <lamby@debian.org>  Fri, 08 Sep 2023 14:13:40 -0700

redis (5:7.2.0-2) experimental; urgency=medium

  * Try and clean up better. (Closes: #1047506)
  * Replace lsb-base dependencies with sysvinit-utils.
  * Drop very old debian/NEWS entry.

 -- Chris Lamb <lamby@debian.org>  Thu, 24 Aug 2023 10:30:17 -0700

redis (5:7.2.0-1) experimental; urgency=medium

  * New upstream stable release.
    <https://raw.githubusercontent.com/redis/redis/7.2/00-RELEASENOTES>
  * Refresh patches.

 -- Chris Lamb <lamby@debian.org>  Fri, 18 Aug 2023 14:17:31 -0400

redis (5:7.2-rc3-1) experimental; urgency=high

  * New upstream security release.
    <https://raw.githubusercontent.com/redis/redis/7.2/00-RELEASENOTES>

    - CVE-2022-24834: A specially-crafted Lua script executing in Redis could
      have triggered a heap overflow in the cjson and cmsgpack libraries and
      result in heap corruption and potentially remote code execution. The
      problem exists in all versions of Redis with Lua scripting support and
      affects only authenticated/authorised users.

    - CVE-2023-36824: Extracting key names from a command and a list of
      arguments may, in some cases, have triggered a heap overflow and result
      in reading random heap memory, heap corruption and potentially remote
      code execution. (Specifically using COMMAND GETKEYS* and validation of
      key names in ACL rules). (Closes: #1040879)

  * Refresh patches

 -- Chris Lamb <lamby@debian.org>  Wed, 12 Jul 2023 09:57:10 +0100

redis (5:7.2-rc2-1) experimental; urgency=medium

  * New upstream release.
    <https://raw.githubusercontent.com/redis/redis/7.2/00-RELEASENOTES>
  * Refresh patches.

 -- Chris Lamb <lamby@debian.org>  Mon, 29 May 2023 07:03:00 -0400

redis (5:7.2-rc1-1) experimental; urgency=medium

  * New upstream security release.

    - CVE-2023-28856: Authenticated users could have used the HINCRBYFLOAT
      command to create an invalid hash field that will crash the Redis server
      on access. (Closes: #1034613)

    For more information, please see:
    <https://raw.githubusercontent.com/redis/redis/7.0/00-RELEASENOTES>

 -- Chris Lamb <lamby@debian.org>  Thu, 20 Apr 2023 07:35:03 +0100

redis (5:7.2~rc1-1) experimental; urgency=medium

  * New upstream experimental 7.2 release.
  * Refresh patches.

 -- Chris Lamb <lamby@debian.org>  Sat, 25 Mar 2023 10:07:53 +0000

=== debian/control ===
Source: redis
Section: database
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libhiredis-dev,
 libjemalloc-dev [linux-any],
 liblua5.1-dev,
 liblzf-dev,
 libssl-dev,
 libsystemd-dev,
 lua-bitop-dev,
 lua-cjson-dev,
 openssl <!nocheck>,
 pkg-config,
 procps <!nocheck>,
 tcl <!nocheck>,
 tcl-tls <!nocheck>,
Standards-Version: 4.6.2
Homepage: https://redis.io/
Vcs-Git: https://salsa.debian.org/lamby/pkg-redis.git -b debian/experimental
Vcs-Browser: https://salsa.debian.org/lamby/pkg-redis
Rules-Requires-Root: no

Package: redis
Architecture: all
Depends:
 redis-server (<< ${binary:Version}.1~),
 redis-server (>= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface (metapackage)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.
 .
 This package depends on the redis-server package.

Package: redis-sentinel
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 redis-tools (= ${binary:Version}),
 sysvinit-utils,
 ${misc:Depends},
Description: Persistent key-value database with network interface (monitoring)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the Redis Sentinel monitoring software.

Package: redis-server
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 redis-tools (= ${binary:Version}),
 sysvinit-utils,
 ${misc:Depends},
Description: Persistent key-value database with network interface
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.

Package: redis-tools
Architecture: any
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ruby-redis,
Description: Persistent key-value database with network interface (client)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the command line client and other tools.

## redis 8.0.0

=== debian/changelog ===
redis (5:8.0.0-2) unstable; urgency=medium

  * Upload 8.x series to unstable after relicensing; we should always prefer to
    ship the latest upstream version, especially given Debian's support
    timelines.
  * Drop all CVE-related patches; applied upstream.
  * Update debian/gbp.conf.

 -- Chris Lamb <lamby@debian.org>  Mon, 12 May 2025 14:43:28 -0700

redis (5:8.0.0-1) experimental; urgency=medium

  * New upstream release under new AGPL-3 licensing scheme.
    - Update debian/copyright.
    - Drop all CVE-related patches; applied upstream.
    - Update and simplify Debian's USE_SYSTEM_JEMALLOC patch.
  * Pass CXXFLAGS when compiling fast_float so that hardening flags are
    correctly passed to this dependency.
  * Refresh patches.
  * Drop unversioned Depends on Essential: yes package sysvinit-utils.
  * Build-Depend on pkgconf over pkg-config.
  * Bump Standards-Version to 4.7.2.

 -- Chris Lamb <lamby@debian.org>  Sun, 11 May 2025 15:23:26 -0700

redis (5:7.2.5-3) experimental; urgency=high

  * Fix two security vulnerabilities:

    - CVE-2024-46981: An authenticated user could have used a specially-crafted
      Lua script to manipulate the garbage collector and potentially lead to
      remote code execution.

    * CVE-2024-51741: An authenticated user with sufficient privileges may have
      created a malformed ACL selector which, when accessed, would have
      triggered a server panic and subsequent denial of service.

    (Closes: #1092370)

 -- Chris Lamb <lamby@debian.org>  Tue, 21 Jan 2025 10:00:03 +0000

redis (5:7.0.15-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * CVE-2025-21605: Limit output buffer for unauthenticated clients
    (Closes: #1104010)

 -- Adrian Bunk <bunk@debian.org>  Fri, 09 May 2025 16:03:22 +0300

## redis 8.0.2

=== modules/Makefile ===

SUBDIRS = redisjson redistimeseries redisbloom redisearch

define submake
	for dir in $(SUBDIRS); do $(MAKE) -C $$dir $(1); done
endef

all: prepare_source
	$(call submake,$@)

get_source:
	$(call submake,$@)

prepare_source: get_source handle-werrors setup_environment

clean:
	$(call submake,$@)

distclean: clean_environment
	$(call submake,$@)

pristine:
	$(call submake,$@)

install:
	$(call submake,$@)

setup_environment: install-rust handle-werrors

clean_environment: uninstall-rust

# Keep all of the Rust stuff in one place
install-rust:
ifeq ($(INSTALL_RUST_TOOLCHAIN),yes)
	@RUST_VERSION=1.80.1; \
	ARCH="$$(uname -m)"; \
	if ldd --version 2>&1 | grep -q musl; then LIBC_TYPE="musl"; else LIBC_TYPE="gnu"; fi; \
	echo "Detected architecture: $${ARCH} and libc: $${LIBC_TYPE}"; \
	case "$${ARCH}" in \
		'x86_64') \
			if [ "$${LIBC_TYPE}" = "musl" ]; then \
				RUST_INSTALLER="rust-$${RUST_VERSION}-x86_64-unknown-linux-musl"; \
				RUST_SHA256="37bbec6a7b9f55fef79c451260766d281a7a5b9d2e65c348bbc241127cf34c8d"; \
			else \
				RUST_INSTALLER="rust-$${RUST_VERSION}-x86_64-unknown-linux-gnu"; \
				RUST_SHA256="85e936d5d36970afb80756fa122edcc99bd72a88155f6bdd514f5d27e778e00a"; \
			fi ;; \
		'aarch64') \
			if [ "$${LIBC_TYPE}" = "musl" ]; then \
				RUST_INSTALLER="rust-$${RUST_VERSION}-aarch64-unknown-linux-musl"; \
				RUST_SHA256="dd668c2d82f77c5458deb023932600fae633fff8d7f876330e01bc47e9976d17"; \
			else \
				RUST_INSTALLER="rust-$${RUST_VERSION}-aarch64-unknown-linux-gnu"; \
				RUST_SHA256="2e89bad7857711a1c11d017ea28fbfeec54076317763901194f8f5decbac1850"; \
			fi ;; \
		*) echo >&2 "Unsupported architecture: '$${ARCH}'"; exit 1 ;; \
	esac; \
	echo "Downloading and installing Rust standalone installer: $${RUST_INSTALLER}"; \
	wget --quiet -O $${RUST_INSTALLER}.tar.xz https://static.rust-lang.org/dist/$${RUST_INSTALLER}.tar.xz; \
	echo "$${RUST_SHA256} $${RUST_INSTALLER}.tar.xz" | sha256sum -c --quiet || { echo "Rust standalone installer checksum failed!"; exit 1; }; \
	tar -xf $${RUST_INSTALLER}.tar.xz; \
	(cd $${RUST_INSTALLER} && ./install.sh); \
	rm -rf $${RUST_INSTALLER}
endif

uninstall-rust:
ifeq ($(INSTALL_RUST_TOOLCHAIN),yes)
	@if [ -x "/usr/local/lib/rustlib/uninstall.sh" ]; then \
		echo "Uninstalling Rust using uninstall.sh script"; \
		rm -rf ~/.cargo; \
		/usr/local/lib/rustlib/uninstall.sh; \
	else \
		echo "WARNING: Rust toolchain not found or uninstall script is missing."; \
	fi
endif

handle-werrors: get_source
ifeq ($(DISABLE_WERRORS),yes)
	@echo "Disabling -Werror for all modules"
	@for dir in $(SUBDIRS); do \
		echo "Processing $$dir"; \
		find $$dir/src -type f \
			\( -name "Makefile" \
			-o -name "*.mk" \
			-o -name "CMakeLists.txt" \) \
			-exec sed -i 's/-Werror//g' {} +; \
	done
endif

.PHONY: all clean distclean install $(SUBDIRS) setup_environment clean_environment install-rust uninstall-rust handle-werrors

=== modules/redisbloom/Makefile ===
SRC_DIR = src
MODULE_VERSION = v8.0.1
MODULE_REPO = https://github.com/redisbloom/redisbloom
TARGET_MODULE = $(SRC_DIR)/bin/$(FULL_VARIANT)/redisbloom.so

include ../common.mk

=== modules/redisearch/Makefile ===
SRC_DIR = src
MODULE_VERSION = v8.0.1
MODULE_REPO = https://github.com/redisearch/redisearch
TARGET_MODULE = $(SRC_DIR)/bin/$(FULL_VARIANT)/search-community/redisearch.so

include ../common.mk

=== modules/redisjson/Makefile ===
SRC_DIR = src
MODULE_VERSION = v8.0.1
MODULE_REPO = https://github.com/redisjson/redisjson
TARGET_MODULE = $(SRC_DIR)/bin/$(FULL_VARIANT)/rejson.so

include ../common.mk

$(SRC_DIR)/.cargo_fetched:
	cd $(SRC_DIR) && cargo fetch

get_source: $(SRC_DIR)/.cargo_fetched

=== modules/redistimeseries/Makefile ===
SRC_DIR = src
MODULE_VERSION = v8.0.1
MODULE_REPO = https://github.com/redistimeseries/redistimeseries
TARGET_MODULE = $(SRC_DIR)/bin/$(FULL_VARIANT)/redistimeseries.so

include ../common.mk

=== tests/modules/Makefile ===

# find the OS
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

warning_cflags = -W -Wall -Wno-missing-field-initializers
ifeq ($(uname_S),Darwin)
	SHOBJ_CFLAGS ?= $(warning_cflags) -dynamic -fno-common -g -ggdb -std=gnu11 -O2
	SHOBJ_LDFLAGS ?= -bundle -undefined dynamic_lookup
else	# Linux, others
	SHOBJ_CFLAGS ?= $(warning_cflags) -fno-common -g -ggdb -std=gnu11 -O2
	SHOBJ_LDFLAGS ?= -shared
endif

ifeq ($(uname_S),Linux)
    LD = gcc
    CC = gcc
endif

# OS X 11.x doesn't have /usr/lib/libSystem.dylib and needs an explicit setting.
ifeq ($(uname_S),Darwin)
ifeq ("$(wildcard /usr/lib/libSystem.dylib)","")
LIBS = -L /Library/Developer/CommandLineTools/SDKs/MacOSX.sdk/usr/lib -lsystem
endif
endif

TEST_MODULES = \
    commandfilter.so \
    basics.so \
    testrdb.so \
    fork.so \
    infotest.so \
    propagate.so \
    misc.so \
    hooks.so \
    blockonkeys.so \
    blockonbackground.so \
    scan.so \
    datatype.so \
    datatype2.so \
    auth.so \
    keyspace_events.so \
    blockedclient.so \
    getkeys.so \
    getchannels.so \
    test_lazyfree.so \
    timer.so \
    defragtest.so \
    keyspecs.so \
    hash.so \
    zset.so \
    stream.so \
    mallocsize.so \
    aclcheck.so \
    list.so \
    subcommands.so \
    reply.so \
    cmdintrospection.so \
    eventloop.so \
    moduleconfigs.so \
    moduleconfigstwo.so \
    publish.so \
    usercall.so \
    postnotifications.so \
    moduleauthtwo.so \
    rdbloadsave.so \
    crash.so \
    internalsecret.so

.PHONY: all

all: $(TEST_MODULES)

32bit:
	$(MAKE) CFLAGS="-m32" LDFLAGS="-m32"

%.xo: %.c ../../src/redismodule.h
	$(CC) -I../../src $(CFLAGS) $(SHOBJ_CFLAGS) -fPIC -c $< -o $@

%.so: %.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LDFLAGS) $(LIBS)

.PHONY: clean

clean:
	rm -f $(TEST_MODULES) $(TEST_MODULES:.so=.xo)

=== debian/changelog ===
redis (5:8.0.2-3ubuntu0.25.10.1) questing-security; urgency=medium

  * SECURITY UPDATE: remote code execution
    - debian/patches/CVE-2025-49844.patch: protect TString on stack
      during parsing to prevent use-after-free condition in lparser.c
    - CVE-2025-49844

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Tue, 14 Oct 2025 00:50:17 +0530

redis (5:8.0.2-3build1) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Thu, 28 Aug 2025 11:33:18 +0000

redis (5:8.0.2-3) unstable; urgency=medium

  * Add a patch to re-add "Redis ver. $REDIS_VERSION" output to the LOLWUT
    ~Easter Egg command output as a some testsuites were relying on it
    existing. This upstream change was made in 8.0.2, not in 8.0.0.

 -- Chris Lamb <lamby@debian.org>  Mon, 14 Jul 2025 09:47:32 -0700

redis (5:8.0.2-2) unstable; urgency=high

  * CVE-2025-32023: An authenticated user may have used a specially-crafted
    string to trigger a stack/heap out-of-bounds write during hyperloglog
    operations, potentially leading to remote code execution. Installations
    that used Redis' ACL system to restrict hyperloglog "HLL" commands are
    unaffected by this issue. (Closes: #1108975)
  * CVE-2025-48367: An unauthenticated connection could have caused repeated IP
    protocol errors, leading to client starvation and ultimately become a
    Denial of Service (DoS) attack. (Closes: #1108981)

 -- Chris Lamb <lamby@debian.org>  Tue, 08 Jul 2025 14:02:33 -0700

redis (5:8.0.2-1) unstable; urgency=medium

  * New upstream security release:

    - CVE-2025-27151: Fix an stack-based buffer overflow in redis-check-aof
      caused by the use of memcpy with strlen(filepath) when copying a
      user-supplied file path into a fixed-size stack buffer. This allowed an
      attacker to overflow the stack and potentially achieve arbitrary code
      execution. (Closes: #1106822)

  * Update debian/watch to consider 8.x versions again after the recent
    licensing change.

 -- Chris Lamb <lamby@debian.org>  Fri, 30 May 2025 12:05:58 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: redis
 Section: database
 Priority: optional
-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  libhiredis-dev,
@@ -13,11 +14,11 @@
  lua-bitop-dev,
  lua-cjson-dev,
  openssl <!nocheck>,
- pkg-config,
+ pkgconf,
  procps <!nocheck>,
  tcl <!nocheck>,
  tcl-tls <!nocheck>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://redis.io/
 Vcs-Git: https://salsa.debian.org/lamby/pkg-redis.git -b debian/experimental
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-redis
@@ -44,7 +45,6 @@
  ${misc:Pre-Depends},
 Depends:
  redis-tools (= ${binary:Version}),
- sysvinit-utils,
  ${misc:Depends},
 Description: Persistent key-value database with network interface (monitoring)
  Redis is a key-value database in a similar vein to memcache but the dataset
@@ -59,7 +59,6 @@
  ${misc:Pre-Depends},
 Depends:
  redis-tools (= ${binary:Version}),
- sysvinit-utils,
  ${misc:Depends},
 Description: Persistent key-value database with network interface
  Redis is a key-value database in a similar vein to memcache but the dataset

## redis 8.0.4

=== .codespell/requirements.txt ===
codespell==2.2.5

=== deps/fast_float/Makefile ===
# Fallback to gcc/g++ when $CC or $CXX is not in $PATH.
CC ?= gcc
CXX ?= g++

CFLAGS=-Wall -O3
# This avoids loosing the fastfloat specific compile flags when we override the CFLAGS via the main project
FASTFLOAT_CFLAGS=-std=c++11 -DFASTFLOAT_ALLOWS_LEADING_PLUS
LDFLAGS=

libfast_float: fast_float_strtod.o
	$(AR) -r libfast_float.a fast_float_strtod.o

32bit: CFLAGS += -m32
32bit: LDFLAGS += -m32
32bit: libfast_float

fast_float_strtod.o: fast_float_strtod.cpp
	$(CXX) $(CFLAGS) $(FASTFLOAT_CFLAGS) -c fast_float_strtod.cpp $(LDFLAGS)

clean:
	rm -f *.o
	rm -f *.a
	rm -f *.h.gch
	rm -rf *.dSYM

=== modules/vector-sets/Makefile ===
# Compiler settings
CC = cc

ifdef SANITIZER
ifeq ($(SANITIZER),address)
	SAN=-fsanitize=address
else
ifeq ($(SANITIZER),undefined)
	SAN=-fsanitize=undefined
else
ifeq ($(SANITIZER),thread)
	SAN=-fsanitize=thread
else
    $(error "unknown sanitizer=${SANITIZER}")
endif
endif
endif
endif

CFLAGS = -O2 -Wall -Wextra -g $(SAN) -std=c11
LDFLAGS = -lm $(SAN)

# Detect OS
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
uname_M := $(shell sh -c 'uname -m 2>/dev/null || echo not')

# Shared library compile flags for linux / osx
ifeq ($(uname_S),Linux)
	SHOBJ_CFLAGS ?= -W -Wall -fno-common -g -ggdb -std=c11 -O2
	SHOBJ_LDFLAGS ?= -shared
ifneq (,$(findstring armv,$(uname_M)))
	SHOBJ_LDFLAGS += -latomic
endif
ifneq (,$(findstring aarch64,$(uname_M)))
	SHOBJ_LDFLAGS += -latomic
endif
else
	SHOBJ_CFLAGS ?= -W -Wall -dynamic -fno-common -g -ggdb -std=c11 -O3
	SHOBJ_LDFLAGS ?= -bundle -undefined dynamic_lookup
endif

# OS X 11.x doesn't have /usr/lib/libSystem.dylib and needs an explicit setting.
ifeq ($(uname_S),Darwin)
ifeq ("$(wildcard /usr/lib/libSystem.dylib)","")
LIBS = -L /Library/Developer/CommandLineTools/SDKs/MacOSX.sdk/usr/lib -lsystem
endif
endif

.SUFFIXES: .c .so .xo .o

all: vset.so

.c.xo:
	$(CC) -I. $(CFLAGS) $(SHOBJ_CFLAGS) -fPIC -c $< -o $@

vset.xo: ../../src/redismodule.h expr.c

vset.so: vset.xo hnsw.xo
	$(CC) -o $@ $^ $(SHOBJ_LDFLAGS) $(LIBS) $(SAN) -lc

# Example sources / objects
SRCS = hnsw.c w2v.c
OBJS = $(SRCS:.c=.o)

TARGET = w2v
MODULE = vset.so

# Default target
all: $(TARGET) $(MODULE)

# Example linking rule
$(TARGET): $(OBJS)
	$(CC) $(OBJS) $(LDFLAGS) -o $(TARGET)

# Compilation rule for object files
%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

expr-test: expr.c fastjson.c fastjson_test.c
	$(CC) $(CFLAGS) expr.c -o expr-test -DTEST_MAIN -lm

# Clean rule
clean:
	rm -f $(TARGET) $(OBJS) *.xo *.so

# Declare phony targets
.PHONY: all clean

=== debian/changelog ===
redis (5:8.0.4-1) unstable; urgency=medium

  * New upstream release.
    - Drop two security patches that were applied upstream.
  * Refresh patches.

 -- Chris Lamb <lamby@debian.org>  Fri, 03 Oct 2025 10:37:53 -0700

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
  https://github.com/redis/redis/tags \
  (?:.*?/)?v?(8\.0\..*)@ARCHIVE_EXT@

## redis 8.0.5

=== deps/Makefile ===
# Redis dependency Makefile

uname_S:= $(shell sh -c 'uname -s 2>/dev/null || echo not')

LUA_DEBUG?=no
LUA_COVERAGE?=no

CCCOLOR="\033[34m"
LINKCOLOR="\033[34;1m"
SRCCOLOR="\033[33m"
BINCOLOR="\033[37;1m"
MAKECOLOR="\033[32;1m"
ENDCOLOR="\033[0m"

default:
	@echo "Explicit target required"

.PHONY: default

# Prerequisites target
.make-prerequisites:
	@touch $@

# Clean everything when CFLAGS is different
ifneq ($(shell sh -c '[ -f .make-cflags ] && cat .make-cflags || echo none'), $(CFLAGS))
.make-cflags: distclean
	-(echo "$(CFLAGS)" > .make-cflags)
.make-prerequisites: .make-cflags
endif

# Clean everything when LDFLAGS is different
ifneq ($(shell sh -c '[ -f .make-ldflags ] && cat .make-ldflags || echo none'), $(LDFLAGS))
.make-ldflags: distclean
	-(echo "$(LDFLAGS)" > .make-ldflags)
.make-prerequisites: .make-ldflags
endif

distclean:
	-(cd hiredis && $(MAKE) clean) > /dev/null || true
	-(cd linenoise && $(MAKE) clean) > /dev/null || true
	-(cd lua && $(MAKE) clean) > /dev/null || true
	-(cd jemalloc && [ -f Makefile ] && $(MAKE) distclean) > /dev/null || true
	-(cd hdr_histogram && $(MAKE) clean) > /dev/null || true
	-(cd fpconv && $(MAKE) clean) > /dev/null || true
	-(cd fast_float && $(MAKE) clean) > /dev/null || true
	-(rm -f .make-*)

.PHONY: distclean

ifneq (,$(filter $(BUILD_TLS),yes module))
    HIREDIS_MAKE_FLAGS = USE_SSL=1
endif

hiredis: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd hiredis && $(MAKE) static $(HIREDIS_MAKE_FLAGS)

.PHONY: hiredis

linenoise: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd linenoise && $(MAKE)

.PHONY: linenoise

hdr_histogram: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd hdr_histogram && $(MAKE)

.PHONY: hdr_histogram

fpconv: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd fpconv && $(MAKE)

.PHONY: fpconv

fast_float: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd fast_float && $(MAKE) libfast_float

.PHONY: fast_float

ifeq ($(uname_S),SunOS)
	# Make isinf() available
	LUA_CFLAGS= -D__C99FEATURES__=1
endif

LUA_CFLAGS+= -Wall -DLUA_ANSI -DENABLE_CJSON_GLOBAL -DREDIS_STATIC='' -DLUA_USE_MKSTEMP $(CFLAGS)
LUA_LDFLAGS+= $(LDFLAGS)
ifeq ($(LUA_DEBUG),yes)
	LUA_CFLAGS+= -O0 -g -DLUA_USE_APICHECK
else
	LUA_CFLAGS+= -O2 
endif
ifeq ($(LUA_COVERAGE),yes)
	LUA_CFLAGS += -fprofile-arcs -ftest-coverage
	LUA_LDFLAGS += -fprofile-arcs -ftest-coverage
endif

# lua's Makefile defines AR="ar rcu", which is unusual, and makes it more
# challenging to cross-compile lua (and redis).  These defines make it easier
# to fit redis into cross-compilation environments, which typically set AR.
AR=ar
ARFLAGS=rc

lua: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd lua/src && $(MAKE) all CFLAGS="$(LUA_CFLAGS)" MYLDFLAGS="$(LUA_LDFLAGS)" AR="$(AR) $(ARFLAGS)"

.PHONY: lua

JEMALLOC_CFLAGS=$(CFLAGS)
JEMALLOC_LDFLAGS=$(LDFLAGS)

ifneq ($(DEB_HOST_GNU_TYPE),)
JEMALLOC_CONFIGURE_OPTS += --host=$(DEB_HOST_GNU_TYPE)
endif

jemalloc: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd jemalloc && ./configure --disable-cxx --with-version=5.3.0-0-g0 --with-lg-quantum=3 --disable-cache-oblivious --with-jemalloc-prefix=je_ CFLAGS="$(JEMALLOC_CFLAGS)" LDFLAGS="$(JEMALLOC_LDFLAGS)" $(JEMALLOC_CONFIGURE_OPTS)
	cd jemalloc && $(MAKE) lib/libjemalloc.a

.PHONY: jemalloc

=== debian/changelog ===
redis (5:8.0.5-1) unstable; urgency=medium

  * New upstream release.
    <https://github.com/redis/redis/releases/tag/8.0.5>

 -- Chris Lamb <lamby@debian.org>  Mon, 03 Nov 2025 08:53:25 -0800

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export BUILD_TLS = yes
export CFLAGS CPPFLAGS LDFLAGS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -I/usr/include/liblzf
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-no-as-needed -ldl -latomic -llzf

# Build jemelloc in parallel
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
	export MAKEFLAGS
endif

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/release.h debian/*.service

override_dh_auto_build:
	dh_auto_build -- V=1 USE_SYSTEM_JEMALLOC=yes USE_SYSTEMD=yes USE_JEMALLOC=yes

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Generate a root CA and server certificate for testing
	./utils/gen-test-certs.sh
	# Avoid race conditions in upstream testsuite
	./runtest --clients 1 --verbose --dump-logs --tls || true
	timeout 30m ./runtest-cluster --tls || true
	./runtest-sentinel || true
	# Clean up after gen-test-certs.sh
	rm -rf tests/tls || true
	# Other cleanup
	find tests/tmp ! -name .gitignore -type f -exec rm -rfv {} +
endif

override_dh_auto_install:
	debian/bin/generate-systemd-service-files

override_dh_compress:
	dh_compress -Xredis-trib.rb

override_dh_installchangelogs:
	dh_installchangelogs --keep 00-RELEASENOTES

## redis 8.4.0

=== deps/Makefile ===
--- 
+++ 
@@ -11,6 +11,23 @@
 BINCOLOR="\033[37;1m"
 MAKECOLOR="\033[32;1m"
 ENDCOLOR="\033[0m"
+
+DEPS_CFLAGS := $(CFLAGS)
+DEPS_LDFLAGS := $(LDFLAGS)
+CLANG := $(findstring clang,$(shell sh -c '$(CC) --version | head -1'))
+
+# MSan looks for errors related to uninitialized memory.
+# Make sure to build the dependencies with MSan as it needs all the code to be instrumented.
+# A library could be used to initialize memory but if it's not build with --fsanitize=memory then
+# MSan doesn't know about it and will spit false positive error when that memory is then used.
+ifeq ($(SANITIZER),memory)
+ifeq (clang, $(CLANG))
+	DEPS_CFLAGS+=-fsanitize=memory -fsanitize-memory-track-origins=2 -fno-sanitize-recover=all -fno-omit-frame-pointer
+	DEPS_LDFLAGS+=-fsanitize=memory
+else
+    $(error "MemorySanitizer needs to be compiled and linked with clang. Please use CC=clang")
+endif
+endif
 
 default:
 	@echo "Explicit target required"
@@ -43,6 +60,7 @@
 	-(cd hdr_histogram && $(MAKE) clean) > /dev/null || true
 	-(cd fpconv && $(MAKE) clean) > /dev/null || true
 	-(cd fast_float && $(MAKE) clean) > /dev/null || true
+	-(cd xxhash && $(MAKE) clean) > /dev/null || true
 	-(rm -f .make-*)
 
 .PHONY: distclean
@@ -51,43 +69,51 @@
     HIREDIS_MAKE_FLAGS = USE_SSL=1
 endif
 
+# Special care is needed to pass additional CFLAGS/LDFLAGS to hiredis as it
+# modifies these variables in its Makefile.
 hiredis: .make-prerequisites
 	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
-	cd hiredis && $(MAKE) static $(HIREDIS_MAKE_FLAGS)
+	cd hiredis && $(MAKE) static $(HIREDIS_MAKE_FLAGS) HIREDIS_CFLAGS="$(DEPS_CFLAGS)" HIREDIS_LDFLAGS="$(DEPS_LDFLAGS)"
 
 .PHONY: hiredis
 
 linenoise: .make-prerequisites
 	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
-	cd linenoise && $(MAKE)
+	cd linenoise && $(MAKE) CFLAGS="$(DEPS_CFLAGS)" LDFLAGS="$(DEPS_LDFLAGS)"
 
 .PHONY: linenoise
 
 hdr_histogram: .make-prerequisites
 	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
-	cd hdr_histogram && $(MAKE)
+	cd hdr_histogram && $(MAKE) CFLAGS="$(DEPS_CFLAGS)" LDFLAGS="$(DEPS_LDFLAGS)"
 
 .PHONY: hdr_histogram
 
 fpconv: .make-prerequisites
 	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
-	cd fpconv && $(MAKE)
+	cd fpconv && $(MAKE) CFLAGS="$(DEPS_CFLAGS)" LDFLAGS="$(DEPS_LDFLAGS)"
 
 .PHONY: fpconv
 
 fast_float: .make-prerequisites
 	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
-	cd fast_float && $(MAKE) libfast_float
+	cd fast_float && $(MAKE) libfast_float CFLAGS="$(DEPS_CFLAGS)" LDFLAGS="$(DEPS_LDFLAGS)"
 
 .PHONY: fast_float
+
+XXHASH_CFLAGS = -fPIC $(DEPS_CFLAGS)
+xxhash: .make-prerequisites
+	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
+	cd xxhash && $(MAKE) lib CFLAGS="$(XXHASH_CFLAGS)" LDFLAGS="$(DEPS_LDFLAGS)"
+.PHONY: xxhash
 
 ifeq ($(uname_S),SunOS)
 	# Make isinf() available
 	LUA_CFLAGS= -D__C99FEATURES__=1
 endif
 
-LUA_CFLAGS+= -Wall -DLUA_ANSI -DENABLE_CJSON_GLOBAL -DREDIS_STATIC='' -DLUA_USE_MKSTEMP $(CFLAGS)
-LUA_LDFLAGS+= $(LDFLAGS)
+LUA_CFLAGS+= -Wall -DLUA_ANSI -DENABLE_CJSON_GLOBAL -DREDIS_STATIC='' -DLUA_USE_MKSTEMP $(DEPS_CFLAGS)
+LUA_LDFLAGS+= $(DEPS_LDFLAGS)
 ifeq ($(LUA_DEBUG),yes)
 	LUA_CFLAGS+= -O0 -g -DLUA_USE_APICHECK
 else

=== modules/redisbloom/Makefile ===
SRC_DIR = src
MODULE_VERSION = v8.4.0
MODULE_REPO = https://github.com/redisbloom/redisbloom
TARGET_MODULE = $(SRC_DIR)/bin/$(FULL_VARIANT)/redisbloom.so

include ../common.mk

=== modules/redisearch/Makefile ===
SRC_DIR = src
MODULE_VERSION = v8.4.2
MODULE_REPO = https://github.com/redisearch/redisearch
TARGET_MODULE = $(SRC_DIR)/bin/$(FULL_VARIANT)/search-community/redisearch.so

include ../common.mk

=== modules/redisjson/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 SRC_DIR = src
-MODULE_VERSION = v8.0.1
+MODULE_VERSION = v8.4.0
 MODULE_REPO = https://github.com/redisjson/redisjson
 TARGET_MODULE = $(SRC_DIR)/bin/$(FULL_VARIANT)/rejson.so

=== modules/redistimeseries/Makefile ===
SRC_DIR = src
MODULE_VERSION = v8.4.0
MODULE_REPO = https://github.com/redistimeseries/redistimeseries
TARGET_MODULE = $(SRC_DIR)/bin/$(FULL_VARIANT)/redistimeseries.so

include ../common.mk

=== tests/modules/Makefile ===
--- 
+++ 
@@ -11,9 +11,27 @@
 	SHOBJ_LDFLAGS ?= -shared
 endif
 
+CLANG := $(findstring clang,$(shell sh -c '$(CC) --version | head -1'))
+
+ifeq ($(SANITIZER),memory)
+ifeq (clang, $(CLANG))
+	LD=clang
+	MALLOC=libc
+	CFLAGS+=-fsanitize=memory -fsanitize-memory-track-origins=2 -fno-sanitize-recover=all -fno-omit-frame-pointer
+	LDFLAGS+=-fsanitize=memory
+else
+    $(error "MemorySanitizer needs to be compiled and linked with clang. Please use CC=clang")
+endif
+endif
+
+
+# This is a hack to override the default CC. When running with SANITIZER=memory
+# tough we want to keep the compiler as clang as MSan is not supported for gcc
 ifeq ($(uname_S),Linux)
-    LD = gcc
-    CC = gcc
+ifneq ($(SANITIZER),memory)
+	LD = gcc
+	CC = gcc
+endif
 endif
 
 # OS X 11.x doesn't have /usr/lib/libSystem.dylib and needs an explicit setting.
@@ -64,7 +82,9 @@
     moduleauthtwo.so \
     rdbloadsave.so \
     crash.so \
-    internalsecret.so
+    internalsecret.so \
+    configaccess.so \
+    atomicslotmigration.so
 
 .PHONY: all

=== debian/changelog ===
redis (5:8.4.0-1) experimental; urgency=medium

  * New upstream release.
    - Refresh patches.
  * Bump Standards-Version to 4.7.3.

 -- Chris Lamb <lamby@debian.org>  Tue, 13 Jan 2026 10:35:58 -0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: redis
 Section: database
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  libhiredis-dev,
@@ -18,7 +17,7 @@
  procps <!nocheck>,
  tcl <!nocheck>,
  tcl-tls <!nocheck>,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://redis.io/
 Vcs-Git: https://salsa.debian.org/lamby/pkg-redis.git -b debian/experimental
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-redis

## redis dashboard-0.0.2

=== Makefile ===
all: clean-pyc test

test:
	python setup.py nosetests --stop --tests tests.py


coverage:
	python setup.py nosetests  --with-coverage --cover-package=redis_dashboard --cover-html --cover-html-dir=coverage_out coverage


shell:
	../venv/bin/ipython

audit:
	python setup.py autdit

release:
	python setup.py sdist upload

clean-pyc:
	find . -name '*.pyc' -exec rm -f {} +
	find . -name '*.pyo' -exec rm -f {} +
	find . -name '*~' -exec rm -f {} +

## redis exporter-1.61.0

=== Makefile ===
.DEFAULT_GOAL := build

DOCKER_COMPOSE := $(if $(shell which docker-compose),docker-compose,docker compose)

.PHONY: build
build:
	go build .


.PHONY: docker-all
docker-all: docker-env-up docker-test docker-env-down


.PHONY: docker-env-up
docker-env-up:
	$(DOCKER_COMPOSE) -f contrib/docker-compose-for-tests.yml up -d


.PHONY: docker-env-down
docker-env-down:
	$(DOCKER_COMPOSE) -f contrib/docker-compose-for-tests.yml down


.PHONY: docker-test
docker-test:
	$(DOCKER_COMPOSE) -f contrib/docker-compose-for-tests.yml up -d
	$(DOCKER_COMPOSE) -f contrib/docker-compose-for-tests.yml run --rm tests bash -c 'make test'



.PHONY: test
test:
	contrib/tls/gen-test-certs.sh
	TEST_REDIS_URI="redis://redis6:6379" \
	TEST_REDIS5_URI="redis://redis5:6383" \
	TEST_REDIS6_URI="redis://redis6:6379" \
	TEST_VALKEY7_URI="redis://valkey7:6384" \
	TEST_REDIS_2_8_URI="redis://redis-2-8:6381" \
	TEST_KEYDB01_URI="redis://keydb-01:6401" \
	TEST_KEYDB02_URI="redis://keydb-02:6402" \
	TEST_PWD_REDIS_URI="redis://:redis-password@pwd-redis5:6380" \
	TEST_USER_PWD_REDIS_URI="redis://exporter:exporter-password@pwd-redis6:6390" \
	TEST_REDIS_CLUSTER_MASTER_URI="redis://redis-cluster:7000" \
	TEST_REDIS_CLUSTER_SLAVE_URI="redis://redis-cluster:7005" \
	TEST_REDIS_CLUSTER_PASSWORD_URI="redis://redis-cluster-password:7006" \
	TEST_TILE38_URI="redis://tile38:9851" \
	TEST_REDIS_SENTINEL_URI="redis://redis-sentinel:26379" \
	go test -v -covermode=atomic -cover -race -coverprofile=coverage.txt -p 1 ./... 

.PHONY: lint
lint:
	#
	# this will run the default linters on non-test files
	# and then all but the "errcheck" linters on the tests
	golangci-lint run --tests=false --exclude-use-default
	golangci-lint run -D=errcheck   --exclude-use-default

.PHONY: checks
checks:
	go vet ./...
	echo "checking gofmt"
	echo " ! gofmt -d *.go       2>&1 | read " | bash
	echo "checking gofmt - DONE"

.PHONY: mixin
mixin:
	cd contrib/redis-mixin && \
	$(MAKE) all && \
	cd ../../

.PHONY: upload-coverage
upload-coverage:
	go install github.com/mattn/goveralls@v0.0.11
	/go/bin/goveralls -coverprofile=coverage.txt -service=drone.io



BUILD_DT:=$(shell date +%F-%T)
GO_LDFLAGS:="-s -w -extldflags \"-static\" -X main.BuildVersion=${DRONE_TAG} -X main.BuildCommitSha=${DRONE_COMMIT_SHA} -X main.BuildDate=$(BUILD_DT)" 


.PHONE: build-some-amd64-binaries
build-some-amd64-binaries:
	go install github.com/oliver006/gox@master

	rm -rf .build | true

	export CGO_ENABLED=0 ; \
	gox -os="linux windows" -arch="amd64" -verbose -rebuild -ldflags $(GO_LDFLAGS) -output ".build/redis_exporter-${DRONE_TAG}.{{.OS}}-{{.Arch}}/{{.Dir}}" && echo "done"


.PHONE: build-all-binaries
build-all-binaries:
	go install github.com/oliver006/gox@master

	rm -rf .build | true

	export CGO_ENABLED=0 ; \
	gox -os="linux windows freebsd netbsd openbsd"        -arch="amd64 386" -verbose -rebuild -ldflags $(GO_LDFLAGS) -output ".build/redis_exporter-${DRONE_TAG}.{{.OS}}-{{.Arch}}/{{.Dir}}" && \
	gox -os="darwin solaris illumos"                      -arch="amd64"     -verbose -rebuild -ldflags $(GO_LDFLAGS) -output ".build/redis_exporter-${DRONE_TAG}.{{.OS}}-{{.Arch}}/{{.Dir}}" && \
	gox -os="darwin"                                      -arch="arm64"     -verbose -rebuild -ldflags $(GO_LDFLAGS) -output ".build/redis_exporter-${DRONE_TAG}.{{.OS}}-{{.Arch}}/{{.Dir}}" && \
	gox -os="linux freebsd netbsd"                        -arch="arm"       -verbose -rebuild -ldflags $(GO_LDFLAGS) -output ".build/redis_exporter-${DRONE_TAG}.{{.OS}}-{{.Arch}}/{{.Dir}}" && \
	gox -os="linux" -arch="arm64 mips64 mips64le ppc64 ppc64le s390x"       -verbose -rebuild -ldflags $(GO_LDFLAGS) -output ".build/redis_exporter-${DRONE_TAG}.{{.OS}}-{{.Arch}}/{{.Dir}}" && \
	echo "done"
